;
; endingppb`
;

	relaxed on


; b800-b802
; 
;
	org	$b800
	jp	START

; b803-b840
; c32~64~Rv[`
; AFLN^ԍ
; BFYW/4i0-49j
; CFXWi0-79j
;
	org	$b803
DRAW64x32:
	ld	a,3
	ld	h,a
	ld	l,0
	add	hl,hl		; x512
	ld	de,$1900
	add	hl,de

	ex	de,hl
	call	CALCVRAM
	ex	de,hl

	jp	nz,DRAW64x32_R

DRAW64x32_L:
	ld	b,8
.lp2:
	push	de
	ld	c,3*16
	ld	a,e
.lp1:
	ld	e,a
	inc	hl
	inc	e
	ldi
	inc	hl
	inc	e
	ldi
	dec	de
	inc	d

	dec	c		; 4x2hbg݂ c -= 3
	jr	nz,.lp1
	pop	de

	inc	e
	inc	e
	inc	e
	inc	e
	jp	z,DRAW64x32_R_CNT

	djnz	.lp2
	ret

; b841-b871
; CӃTCY
; HFTCY
; LFcTCY
; BFYW/4i0-49j
; CFXWi0-79j
;
	org	$b841
ERASEHxL:
	ld	a,49
	cp	b
	ret	c
	ld	a,79
	cp	c
	ret	c

	srl	l
	srl	l

	ex	de,hl
	call	CALCVRAM

	ld	b,d		; [v
	ld	c,e		; c[v
	ld	d,$00		; p^[

	jp	nz,ERASEHxL_R

ERASEHxL_L:

.lp2:
	push	hl
	ld	e,c		; c[v
	sla	e
	ld	a,l
.lp1:
	ld	l,a
;	ld	(hl),d
	inc	l
	ld	(hl),d
	inc	l
;	ld	(hl),d
	inc	l
	ld	(hl),d

	inc	h
	dec	e
	jr	nz,.lp1
	pop	hl

	inc	l
	inc	l
	inc	l
	inc	l
	jp	z,ERASEHxL_R_CNT

	djnz	.lp2
	ret

; b872-b888
; VRAMAhXZo
; BFYWi/8j
; CFXWi/4j
; RETURN
; HLFVRAMAhX
; ZflagF1̎
;
	org	$b872
CALCVRAM:
	bit	6,c
	jp	nz,CALCVRAM_R

CALCVRAM_L:
	push	af
	ld	a,b
	add	a,a
	add	a,$1a
	ld	h,a
	ld	a,c
	add	a,a
	add	a,a
	ld	l,a
	pop	af
	ret

; b889-b8ac
; wi̐`
;
	org	$b889
DRAWSTAR:
	call	VRAMBIT
	ld	hl,$b8ee

	ld	a,$0d		; iRhbgj
	ld	(STARSUB.pat1+1),a
;	ld	(STARSUB.pat2+1),a
	ld	bc,-12		; ړR
	ld	a,$1a		; ^C}f[^
	call	$b8ad

	ld	a,$0c		; iQhbgj
	ld	(STARSUB.pat1+1),a
	ld	bc,-8		; ړQ
	ld	a,$28		; ^C}f[^
	call	$b8ad

	jp	DRAWSTAR_CNT

; b8ad-b8af
; wi̐`
;
	org	$b8ad
	ld	(STARSUB.tim+1),a

; b8b0-
; ̂܂܎gp
;
	org	$b8b0
	db	$ff

; b8c0-b8ed
; wi̐`
;
	org	$b8c0
STARSUB:
	ld	a,(hl)		; PځFYW
	out	($ce),a
	inc	hl
	ld	e,(hl)		; QځFXW/2
	ld	d,$00
	ex	de,hl
	add	hl,hl
;	ld	(hl),$00	; 
	inc	hl
	inc	hl
	ld	(hl),$00	; 
	ex	de,hl
	inc	hl
	dec	(hl)		; RځF^C}
	jr	z,.tful		; ^C}Wv
	ex	de,hl
	add	hl,bc
.pat1:	ld	(hl),$0d	; `
	dec	hl
	dec	hl
;.pat2:	ld	(hl),$0d	; `
	ex	de,hl
	srl	d
	rr	e
.end:	dec	hl
	ld	(hl),e		; QځFXW/2
	dec	hl
	ret

.tful:
.tim:	ld	(hl),$00	; RځF^C}Đݒ
	ld	e,$9e		; ĐݒpXW
	jr	.end


; b8ee-b965
; wi̐`if[^j
;
	org	$b8ee

	db	$14,$6e,$12,$00,$00
	db	$28,$3c,$0a,$00,$00
	db	$2d,$1c,$04,$00,$00
	db	$45,$64,$10,$00,$00
	db	$4b,$8c,$17,$00,$00
	db	$64,$9c,$1a,$00,$00
	db	$78,$32,$08,$00,$00
	db	$8c,$50,$0d,$00,$00

	db	$2a,$2a,$0a,$00,$00
	db	$4b,$5c,$17,$00,$00
	db	$2d,$1c,$07,$00,$00
	db	$45,$64,$19,$00,$00
	db	$64,$5a,$16,$00,$00
	db	$7f,$1e,$07,$00,$00
	db	$8a,$86,$21,$00,$00
	db	$a0,$3c,$0f,$00,$00

	db	$2a,$2a,$15,$00,$00
	db	$4b,$5c,$2e,$00,$00
	db	$60,$9c,$4e,$00,$00
	db	$8e,$3a,$1d,$00,$00
	db	$98,$64,$32,$00,$00
	db	$a2,$3c,$1e,$00,$00
	db	$78,$32,$19,$00,$00
	db	$8c,$50,$28,$00,$00

; b966-
; ̂܂܎gp
;
	org	$b966
	db	$ff

; b977-bab0
; \i񊿎pj
; HLF\擪AhX
; DEFVRAMAhX
;

MOJIBUF	equ	$c500		; tHgpobt@

	org	$b977
DISPMOJI:
.lp1:
	ld	a,(hl)		; AhX
	or	a
	ret	z

	cp	$81		; ǂݔ΂
	jr	nz,.n12
	inc	hl
	ld	a,(hl)
	cp	$7c		; - ϊ
	jr	nz,.lp1
	ld	a,"-"
.n12:
	push	hl

	push	de
	ld	e,a
	ld	d,0
	call	READMOJI
	pop	de

	push	de
	call	RAMACC_WR


	ld	b,6
	ld	c,7
	ld	hl,MOJIBUF
.lp2:
	ld	a,(hl)
	dec	c
	jr	nz,.next1
	inc	hl
	inc	hl
	or	(hl)
	dec	hl
	dec	hl
	ld	c,1
.next1:
	inc	hl
	ld	(de),a
	inc	e
	inc	e
	inc	e
	inc	e

	ld	a,(hl)
	dec	c
	jr	nz,.next2
	inc	hl
	inc	hl
	or	(hl)
	ld	c,7
.next2:
	inc	hl
	ld	(de),a
	dec	e
	dec	e

	ld	a,(hl)
	dec	c
	jr	nz,.next3
	inc	hl
	inc	hl
	or	(hl)
	dec	hl
	dec	hl
	ld	c,1
.next3:
	inc	hl
	ld	(de),a
	inc	e
	inc	e
	inc	e
	inc	e

	ld	a,(hl)
	dec	c
	jr	nz,.next4
	inc	hl
	inc	hl
	or	(hl)
	ld	c,7
.next4:
	inc	hl
	ld	(de),a
	ld	a,e
	sub	6
	ld	e,a
	inc	d
	djnz	.lp2

	pop	de
	ld	a,e
	add	a,8
	ld	e,a

	call	RAMACC_RD

	pop	hl
	inc	hl

	jr	.lp1

;
; Spf[^obt@ɓ]i񊿎̂݁j
; DEFR[h
; RETURN
; (MOJIBUF)F2*16oCgŃf[^i[
;
READMOJI:
	push	ix
	push	hl
	push	bc

	ld	a,d
	or	a
;	jr	nz,.kanji
	jr	nz,.spc

	ld	a,$d0		;0x4000`0x5FFF̓ǂݏoCGROM(0x0000`)ɂ
	out	($62),a
	ld	a,$d2		;0x6000`0x6FFF̓ǂݏoCGROM(0x2000`)ɂ
	out	($63),a

	ld	c,e
	ld	ix,MOJITABLE
	ld	b,(ix+0)	; e[u
	inc	ix

.mlp1:
	ld	a,(ix+1)	; 
	cp	c
	jr	c,.next

	ld	a,c
	sub	(ix+0)		; 
	jr	nc,.find
.next:
	ld	de,7
	add	ix,de
	djnz	.mlp1

	ld	a,c
	ld	hl,$1002+$4000
	cp	''
	jr	z,.wo

	ld	hl,$0fe2+$4000
	cp	''-$20
	jr	z,.wo

	jr	.spc


.find:
	ld	l,a
	ld	h,0
	ld	b,(ix+2)	; 搔
.mlp2:	add	hl,hl
	djnz	.mlp2

	ld	e,(ix+5)	; i[擪AhX
	ld	d,(ix+6)	; i[擪AhX

	add	hl,de
	ld	de,MOJIBUF

	ld	a,32		; ރf[^
.mlp4:
	ld	c,(ix+3)	; xɓǂݍރoCg
	ld	b,0
.mlp3:
	dec	a
	ldi
	jp	pe,.mlp3

	ex	af,af'
	ld	a,(ix+4)	; ̃f[^܂ł̃oCg
	add	a,l
	ld	l,a
	jr	nc,.noinc
	inc	h
.noinc:
	ex	af,af'
	or	a
	jr	nz,.mlp4

	jr	.end

;.kanji:
;	sub	$80-$40
;	ld	d,a
;	push	de
;
;	ld	a,$e8			;0x4000`0x5FFF̓ǂݏoROM(0x8000`)ɂ
;	out	($62),a
;	ld	a,$ea			;0x6000`0x6FFF̓ǂݏoROM(0xa000`)ɂ
;	out	($63),a
;
;	ld	bc,$10ff
;	ld	hl,MOJIBUF
;	ex	de,hl
;.klp1:
;	ldi
;	inc	de
;	djnz	.klp1
;
;	pop	de
;
;	ld	a,$ec			;0x4000`0x5FFF̓ǂݏoROM(0xc000`)ɂ
;	out	($62),a
;	ld	a,$ee			;0x6000`0x6FFF̓ǂݏoROM(0xe000`)ɂ
;	out	($63),a
;
;	ld	bc,$10ff
;	ld	hl,MOJIBUF+1
;	ex	de,hl
;.klp2:
;	ldi
;	inc	de
;	djnz	.klp2
;
;	jr	.end

.wo:
	ld	de,MOJIBUF
	ld	bc,32
	ldir

	jr	.end

.spc:
	xor	a
	ld	b,32
	ld	hl,MOJIBUF
.slp1:
	ld	(hl),a
	inc	hl
	djnz	.slp1

.end:
	ld	a,$24			;0x4000`0x5FFF̓ǂݏoORAMɂ
	out	($62),a
	ld	a,$26			;0x4000`0x5FFF̓ǂݏoORAMɂ
	out	($63),a

	pop	bc
	pop	hl
	pop	ix
	ret

; bab1-
; ̂܂܎gp
;
	org	$bab1
	db	$ff

; bad0-bb05
; pbgݒitF[hC^AEgpj
;
	org	$bad0
SETPAL:
	push	de
	push	hl
	res	0,a		; 0,2,4,6
	add	a,a		; x2
	ld	h,0
	ld	l,a
	ld	de,PALTBL
	add	hl,de

	ld	bc,4*$0100 + $40-1
.lp1:
	inc	c
	outi
	jr	nz,.lp1

	pop	hl
	pop	de
	ret

PALTBL:
	db	$0f!$08, $0f!$08 ,$0f!$08, $0f!$08	; 0x00F@A@A@A
	db	$0f!$09, $0f!$09 ,$0f!$08, $0f!$08	; 0x01F@A@A@A
	db	$0f!$07, $0f!$05 ,$0f!$0a, $0f!$08	; 0x02FDFAFAԁ@A
	db	$0f!$0f, $0f!$05 ,$0f!$03, $0f!$08	; 0x03F@AFAԎA

; bb06-bb08
; ԑ҂
;
	org	$bb06
	ld	hl,42		; 100 / 8 * 3.5

; bb09-
; ̂܂܎gp
;
	org	$bb09
	db	$ff

; bb12-bb2d
; QhbgXN[iRv[̂݁j
;
	org	$bb12
SCRUP_M:
	call	RAMACC_WR

	call	SCRUP2

	ld	a,(SCRUP2.posy+1)
	add	a,25
	cp	$1a+25*4
	jr	c,.n1
	ld	a,$1a
.n1:
	ld	(SCRUP2.posy+1),a

	jp	RAMACC_RD



; bb2e-bb72
; ʃNA
;
	org	$bb2e
GCLS:
	xor	a
	call	RAMACC_W

	di
	ld	(.sppt+1),sp
	ld	sp,$8000
	ld	hl,$0000
	ld	c,8
.lp2:
	ld	b,0
.lp1:
	REPT	8
	push	hl
	ENDM

	djnz	.lp1
	dec	c
	jp	nz,.lp2

.sppt:	ld	sp,$0000
	ei

	ld	a,$20

;
; 0x0000-0x7fff݂̏ύX
;
RAMACC_W:
	out	($68),a
	add	a,2
	out	($69),a
	add	a,2
	out	($6a),a
	add	a,2
	out	($6b),a
	ret

; bb73-bb81
; ԑ҂
;
	org	$bb73
W_TIME:
	ld	b,$0f
.lp1:
	djnz	.lp1
	ret

; bb82-
; ̂܂܎gp
;
	org	$bb82
	db	$ff

; bec6-bec8
; @ړ
;
	org	$bec6
	call	MOVECHR

; bec9-
; ̂܂܎gp
;
	org	$bec9
	db	$ff

; befa-beff
; pbgݒ
;
	org	$befa
	jr	$bf00

; bf00-
; ̂܂܎gp
;
	org	$bf00
	db	$ff

; bf15-bf1c
; pbgݒ
;
	org	$bf15
	ld	a,$0f!$0f
	out	($40),a		; pbgݒi"11"=j
	out	($42),a		; pbgݒi"01"=ԁj
	nop
	nop

;	out	($41),a		; pbgݒi"10"=Fj
;	out	($43),a		; pbgݒi"00"=j

; bf1d-
; ̂܂܎gp
;
	org	$bf1d
	db	$ff

; bf20-bf25
; \
;
	org	$bf20
	ld	de,$7854
	call	DISPMOJI

; bf26-
; ̂܂܎gp
;
	org	$bf26
	db	$ff

; bf6b-bf82
; I
;
	org	$bf6b
ENDPROC:
	ld	de,$1900	; i[AhX
	ld	hl,FILEZAKO
	ld	a,$ff
	call	$854b		; t@Cǂݏo

	ld	a,$07
	call	SETPAL

	di
.sppt:	ld	sp,$0000
	ei
	jr	$bf83

; bf83-
; ̂܂܎gp
;
	org	$bf83
	db	$ff

; c380-c4fe
; ǉvO
;
	org	$c380

;
; URLt@C
;
FILEZAKO:
	db	"zako  chr"

;
; 񊿎i[ꏊȂ
;
MOJITABLE:
	db	5	; e[u

			; 0x21-0x3F
	db	$21	; ŏ̕
	db	$3f	; Ō̕
	db	$07	; ̕܂ł̃oCg̏搔
	db	$04	; xɓǂݍރoCg
	db	$10-$04	; ̃f[^܂ł̃oCg
	dw	$408c	; ŏ̊̕i[擪AhX

			; 0x40-0x7F
	db	$40	; ŏ̕
	db	$7f	; Ō̕
	db	$06	; ̕܂ł̃oCg̏搔
	db	$08	; xɓǂݍރoCg
	db	$10-$08	; ̃f[^܂ł̃oCg
	dw	$5008	; ŏ̊̕i[擪AhX

			; 0x90-0x9F
	db	$90	; ŏ̕
	db	$9f	; Ō̕
	db	$08	; ̕܂ł̃oCg̏搔
	db	$02	; xɓǂݍރoCg
	db	$10-$02	; ̃f[^܂ł̃oCg
	dw	$700a	; ŏ̊̕i[擪AhX

			; 0xB1-0xBF
	db	$b0	; ŏ̕
	db	$bf	; Ō̕
	db	$08	; ̕܂ł̃oCg̏搔
	db	$02	; xɓǂݍރoCg
	db	$10-$02	; ̃f[^܂ł̃oCg
	dw	$600a	; ŏ̊̕i[擪AhX

			; 0xC0-0xFF
	db	$c0	; ŏ̕
	db	$ff	; Ō̕
	db	$07	; ̕܂ł̃oCg̏搔
	db	$04	; xɓǂݍރoCg
	db	$10-$04	; ̃f[^܂ł̃oCg
	dw	$600c	; ŏ̊̕i[擪AhX

;
; rbg}bv[hɐݒ
;
VRAMBIT:
	push	af
	ld	a,$e2		; rbg}bv[hɐݒ
	out	($c8),a
	xor	a		; 0x0000-0x1FFF̓ǂݏRAMɂ
	out	($60),a
	out	($68),a
	pop	af
	ret

;
; ڃANZX[hɐݒ
;
VRAMDIR:
	push	af
	ld	a,$ea		; ڃANZX[hɐݒ
	out	($c8),a
	ld	a,$20		; 0x0000-0x1FFF̓ǂݏORAMɂ
	out	($60),a
	out	($68),a
	pop	af
	ret

;
; 0x0000-0x7fff̓ǂݏORAMɂ
;
RAMACC_WR:
	xor	a
	out	($60),a
	out	($68),a
	add	a,2
	out	($61),a
	out	($69),a
	add	a,2
	out	($62),a
	out	($6a),a
	add	a,2
	out	($63),a
	out	($6b),a
	ret

;
; 0x0000-0x7fff̓ǂݏ߂
;
RAMACC_RD:

	ld	a,$20		; ǂݏoRAM
	out	($60),a
	add	a,2
	out	($61),a
	add	a,2
	out	($62),a
	add	a,2
	out	($63),a
	xor	a		; ݂RAM
	out	($68),a
	add	a,2
	out	($69),a
	add	a,2
	out	($6a),a
	add	a,2
	out	($6b),a
	ret

;;
;; PhbgXN[
;; iRv[̂݁j
;; X=0x5438x8hbg
;;
;SCRUP:
;	ld	c,38		; 
;	ld	l,$54		; JnXAhX
;	ld	e,$54+2		; JnXAhX
;
;.lp2:
;	ld	h,$1a		; JnYAhX
;	ld	d,h
;	ld	b,100		; XN[C
;.lp1:
;	ld	a,(de)		; 0+0x02 -> 0+0x00
;	ld	(hl),a
;	inc	h
;	ld	a,(hl)		; 1+0x00 -> 0+0x02
;	ld	(de),a
;	inc	d
;	djnz	.lp1
;
;	ld	b,4
;	ld	a,l
;	add	a,b
;	ld	l,a
;	ld	a,e
;	add	a,b
;	ld	e,a
;
;	dec	c
;	jp	nz,.lp2
;
;	ret

;
; QhbgXN[
; iRv[̂݁j
; X=0x5438x8hbg
;
SCRUP2:
	ld	c,38*2		; 
	ld	l,$54		; JnXAhX
	ld	e,l		; JnXAhX

.lp2:
.posy:	ld	h,$1a		; JnYAhX
	ld	d,h
	inc	d		; JnYAhX
	ld	b,25		; XN[C
.lp1:
	ld	a,(de)		; 1+0x00 -> 0+0x00
	ld	(hl),a
	inc	h
	inc	d
	djnz	.lp1

	inc	l
	inc	l
	inc	e
	inc	e

	dec	c
	jp	nz,.lp2

	ret

;
; wi̐`ij
;
DRAWSTAR_CNT:
	ld	a,$04		; iPhbgj
	ld	(STARSUB.pat1+1),a
;	ld	a,$02		; /
;	ld	(STARSUB.pat2+1),a
	ld	bc,-4		; ړP
	ld	a,$50		; ^C}f[^
	call	$b8ad

	jp	VRAMDIR

;
; 64x32`iEj
; HLFp^[AhX
; DEFVRAMAhX
;
DRAW64x32_R:

	ld	b,8
.lp2:
	push	de
	ld	c,5*8
	ld	a,e
.lp1:
	ld	e,a
	inc	hl
	inc	e
	ldi
	inc	hl
	inc	e
	ldi
	dec	de
	inc	d
	ld	e,a
	inc	hl
	inc	e
	ldi
	inc	hl
	inc	e
	ldi
	dec	de
	dec	d

	add	a,$40
	jr	nc,.n1
	inc	d
	inc	d
.n1:
	dec	c		; 4x4hbg݂ c -= 5
	jr	nz,.lp1

	pop	de
	inc	e
	inc	e
	inc	e
	inc	e
.cont:
	djnz	.lp2
	ret

DRAW64x32_R_CNT:
	call	CALCVRAM_L2R

	jr	DRAW64x32_R.cont

;
; `iEj
; HLFp^[AhX
; DEFVRAMAhX
;
ERASEHxL_R:

.lp2:
	push	hl
	ld	e,c		; c[v
	ld	a,l
.lp1:
	ld	l,a
;	ld	(hl),d
	inc	l
	ld	(hl),d
	inc	l
;	ld	(hl),d
	inc	l
	ld	(hl),d
	inc	h

	ld	l,a
;	ld	(hl),d
	inc	l
	ld	(hl),d
	inc	l
;	ld	(hl),d
	inc	l
	ld	(hl),d
	dec	h

	add	a,$40
	jr	nc,.n1
	inc	h
	inc	h
.n1:
	dec	e
	jr	nz,.lp1

	pop	hl
	inc	l
	inc	l
	inc	l
	inc	l
.cont:
	djnz	.lp2
	ret

ERASEHxL_R_CNT:
	ex	de,hl
	call	CALCVRAM_L2R
	ex	de,hl

	jr	ERASEHxL_R.cont

;
; VRAMAhXiEjZo
; BFYWi/8j
; CFXWi/4j
; RETURN
; HLFVRAMAhX
;
CALCVRAM_R:

	push	af

	ld	a,b

	rrca
	rrca				; Y5-0 => Y1-0,,Y5-2
	and	$c0			; Y1-0 => b7,6
	ld	l,a

	ld	a,c
	add	a,a
	add	a,a
	add	a,l
	ld	l,a

	ld	a,b
	rrca				; Y0,,Y5-1
	and	$1e			; Y5-2 => b4-1
	ld	h,a

	pop	af
	ret

;
; VRAMAhXEZo
; DFVRAMAhX
; DEFVRAMEAhX
;
CALCVRAM_L2R:
	ld	a,d
	sub	$1a
	srl	a
	ld	d,a

	rrca
	rrca				; Y5-0 => Y1-0,,Y5-2
	and	$c0			; Y1-0 => b7,6
	ld	e,a

	ld	a,d
	rrca				; Y0,,Y5-1
	and	$1e			; Y5-2 => b4-1
	ld	d,a

	ret

;
; @ړ
;
MOVECHR:
	xor	a
	call	RAMACC_W
	call	$bb82
	ld	a,$20
	jp	RAMACC_W

;
; 
;
START:
	di
	ld	(ENDPROC.sppt+1),sp
	ld	sp,$b800
	ei
	ld	a,$1a
	ld	(SCRUP2.posy+1),a
	jp	$bee0

; c4ff-
; ̂܂܎gp
;
	org	$c4ff
	db	$ff


end

