;
; game startp
;

	relaxed on

BGMSTOP		equ	$8d03
DISKLOAD	equ	$854b


	org	$f000

	jp	GAMESTART	; 0xf000
	jp	DRAWFILE	; 0xf003

SP_STORE:
	dw	$0000		; 0xf006

;
; Q[N
; AFʏ펞A0x00FfA0x01`0x04
;
GAMESTART:
	ld	($fff8),a

	call	BGMSTOP		; BGM~߂
	di
	ld	sp,(SP_STORE)

	call	setpal		; AiOpbgݒ
	ld	hl,$d000	; window.drw
	call	DRAWFILE
	ld	e,$06
	call	FADEIN

	ld	sp,$b500
	ei

	ld	de,$b800
	push	de
	ld	de,$b500
	ld	hl,L_GAME
	ld	a,0ffh
	jp	DISKLOAD

L_GAME:
	db	"game  obj"

;
; tF[hC
;
FADEIN:
	xor	a
.lp1:
	push	af
	call	SETPAL		; AiOpbgݒ
	call	T_WAIT		; ԑ҂
	pop	af
	inc	a
	cp	$08
	jr	nz,.lp1
	ret

;
; pbgݒitF[hC^AEgpj
;
SETPAL:
	push	de
	push	hl
	res	0,a		; 0,2,4,6
	add	a,a		; x2
	ld	h,0
	ld	l,a
	ld	de,.paltbl
	add	hl,de

	ld	bc,4*$0100 + $40-1
.lp1:
	inc	c
	outi
	jr	nz,.lp1

	pop	hl
	pop	de
	ret

.paltbl:
	db	$0f!$08, $0f!$08 ,$0f!$08, $0f!$08	; 0x00F@A@A@A
	db	$0f!$09, $0f!$09 ,$0f!$08, $0f!$08	; 0x01F@A@A@A
	db	$0f!$07, $0f!$05 ,$0f!$0a, $0f!$08	; 0x02FDFAFAԁ@A
	db	$0f!$0f, $0f!$05 ,$0f!$03, $0f!$08	; 0x03F@AFAԎA

;
; ԑ҂
T_WAIT:
.lp2:
	ld	hl,42		; 100 / 8 * 3.5
.lp1:
	dec	hl
	ld	a,h
	or	l
	jr	nz,.lp1
	dec	e
	jr	nz,.lp2
	ret

;
; drw`掞VRAMݒ1
;
SETDRWVRAM1:
	ld	a,$00		; 0x0000-0x3FFF̓ǂݏRAMɂ
	out	($60),a
	out	($68),a
	add	a,2
	out	($61),a
	out	($69),a
	ld	a,d
	and	$c0
	rrca
	rrca
	rrca
	rrca			; 0x4000-0x7FFF̓ǂݏRAMɂ
	out	($62),a
	out	($6a),a
	add	a,2
	out	($63),a
	out	($6b),a
	ret

;
; drw`掞VRAMݒ2
;
SETDRWVRAM2:
	ld	a,d
	and	$c0
	rrca
	rrca
	rrca
	rrca			; 0x0000-0x3FFF̓ǂݏRAMɂ
	out	($60),a
	out	($68),a
	add	a,2
	out	($61),a
	out	($69),a
	ld	a,$04		; 0x4000-0x7FFF̓ǂݏRAMɂ
	out	($62),a
	out	($6a),a
	add	a,2
	out	($63),a
	out	($6b),a
	ret

;
; drw`掞VRAMݒ߂
;
RETDRW:
	ld	a,$20		; 0x0000-0x7FFF̓ǂݏORAMɂ
	out	($60),a
	out	($68),a
	add	a,2
	out	($61),a
	out	($69),a
	add	a,2
	out	($62),a
	out	($6a),a
	add	a,2
	out	($63),a
	out	($6b),a
	ret

;
; t@C̓e`
;
DRAWFILE:
	ld	d,h
	push	de
	call	SETDRWVRAM1
	res	7,h
	set	6,h
	ld	de,$0000	; VRAMAhXi0x0000Œj
	call	DISKDRAW
	pop	de

	dec	hl
	dec	hl

	call	SETDRWVRAM2
	res	7,h
	res	6,h
	ld	de,$4000	; VRAMAhXi0x0000Œj
	call	DISKDRAW

	jp	RETDRW


; ̓eWJ
;
; lzsa 1.3.3gp
; https://github.com/emmanuel-marty/lzsa/releases/
; lzsa.exe -f2 -r <sourcefile> <outfile>
;
; WJvÓAȉgp
; https://github.com/uniabis/z80depacker/unlzsa2_fast.asm
;
; @Ⴄ̂ŁAȉC
; E}`Xe[ggWJ
; EMACRO`
; EZ80jjbN̏C
;
;
; HLFkf[^擪
;
DISKDRAW:

	include "unlzsa2_fast_mod.asm"

; f1ff-
; ̂܂܎gp
;
	org	$f1ff
	db	$ff

end

