;
; Np
;

	relaxed on

	include	"pc60_hira.asm"

Disk_Routine	equ	$8800

Disk_Init	equ	Disk60_Entry+0
Disk_Load	equ	Disk60_Entry+3
Disk_Change1DD	equ	Disk60_Entry+12

FILE_LOAD	equ	$854b


	org	$c000

;
; Track#0 Sector#1`
;
	db	"IPL"		; +0
	jr	START		; +3

;
; ZN^ǂݍ݁iROM[`gpj
;
READ_NSEC:
.loop:
	push	af
	ld	a,$01
	or	a
	push	bc
	push	de
	call	$0198		; ZN^ǂݍ
	pop	de
	pop	bc
	inc	d
	inc	c
	pop	af
	dec	a
	jr	nz,.loop
	ret

;
; 0x0000-0x7FFF̓ǂݏORAMɂ
;
ACCMRAM:
	ld	a,$20
	out	($60),a
	out	($68),a
	add	a,2
	out	($61),a
	out	($69),a
	add	a,2
	out	($62),a
	out	($6a),a
	add	a,2
	out	($63),a
	out	($6b),a
	ret

START:
	xor	a		; hCuԍ-1
	ld	($ed66),a

	ld	bc,$0002	; Breg:gbNԍACreg:ZN^ԍ
	ld	de,$c100	; i[AhX
	ld	a,$04		; ǂݍރZN^
	call	READ_NSEC

	call	CURCLS		; ʃNA

	ld	bc,$0006	; BregFgbNԍACregFZN^ԍihCupǂݏo[`j
	ld	a,($ed5a)	; bit7`0 = Ot#2A#1A#2A#1A"0000"
	bit	4,a
	jr	nz,.fd_in
	ld	bc,$0009	; BregFgbNԍACregFZN^ԍiOthCupǂݏo[`j

.fd_in:

;
; fBXNǂݏ[`[h
;
	ld	de,Disk_Routine	; i[擪AhX
	ld	a,$03		; ǂݍރZN^
	call	READ_NSEC

;
; 荞ݏȂǂ[h
;
	ld	bc,$000c	; BregFgbNԍACregFZN^ԍ
	ld	de,$8500	; i[擪AhX
	ld	a,$03		; ǂݍރZN^
	call	READ_NSEC

	di

	ld	sp,$b500

;
; VRAMNA
;
	ld	hl,$0000
.lp1:	ld	(hl),$00
	inc	hl
	ld	a,h
	cp	$80
	jr	nz,.lp1

	call	ACCMRAM		; 0x0000-0x7FFF̃̓ǂݏOtɂ

;
; OtRAM̃`FbN
;
	ld	bc,$5aa5
	ld	de,$9669
	ld	hl,$0000
	ld	(hl),b
	ld	h,$40
	ld	(hl),c
	ld	h,$80
	ld	(hl),d
	ld	h,$d0
	ld	(hl),e

	ld	h,$00
	ld	a,(hl)
	cp	b
	jp	nz,RAMNG
	ld	h,$40
	ld	a,(hl)
	cp	c
	jp	nz,RAMNG
	ld	h,$80
	ld	a,(hl)
	cp	d
	jp	nz,RAMNG
	ld	h,$d0
	ld	a,(hl)
	cp	e
	jp	nz,RAMNG

;
; fBXN[`̏
;
	ld	d,$00
	call	Disk_Init
	jp	c,DISKERR

	ld	d,$00
	call	Disk_Change1DD
	jp	c,DISKERR

;
; o[W\
;
	ld	de,VER_MSG
	call	PNT_MSG

	ld	bc,2500
	call	WAITTIME

;
; VXȅ
;
SYSINIT:
	im	2
	ld	a,$87
	ld	i,a		; 荞݃e[u0x8700`ɐݒ

	ld	a,$ea		; 荞݂VSYNCA^C}ASUB-CPÛ݂ɂ
	out	($fa),a

	ld	a,$3f
	out	($f6),a		; ^C}̊荞݊Ԋu1msɂ


	ld	a,$00		; wait SOFFɂ
	out	($f3),a


	ld	a,$02
	out	($93),a		; ʂ

	ld	a,$fb		; CSS3-1=011
	out	($c0),a

	ld	a,$f3		; 640x200 OtBbN
	out	($c1),a

	ld	a,$e2		; rbg}bv[hɐݒ^y[WO\
	out	($c8),a

	ld	bc,$07c9
	xor	a
.outlp2:
	out	(c),a
				; 0xC9:VRAM}bv̐ݒ
				; 0xCA:XN[XW̐ݒ
				; 0xCB:XN[XW̐ݒ
				; 0xCC:XN[YW̐ݒ
				; 0xCD:XN[YW̐ݒ
				; 0xCE:YWiʁj̐ݒ
				; 0xCF:YWiʁj̐ݒ
	inc	c
	djnz	.outlp2

	ld	a,$0f!$0f
	out	($40),a		; pbgݒi"11"=j
	ld	a,$0f!$05
	out	($41),a		; pbgݒi"10"=Fj
	ld	a,$0f!$0a
	out	($42),a		; pbgݒi"01"=ԁj
	ld	a,$0f!$08
	out	($43),a		; pbgݒi"00"=j

	ld	a,$03
	out	($93),a		; ʂ\

	ld	de,$07bf	; ~LT[FSďo͂Ȃ
	call	OUTOPN

	ld	b,3
	ld	de,$0800	; `l``b̉
.lp1:	call	OUTOPN
	inc	d
	djnz	.lp1

	ld	b,3
	ld	de,$2800	; S`lL[It
.lp2:	call	OUTOPN
	inc	e
	djnz	.lp2

	ei

	call	DISPTITLE

	ld	de,$9400
	ld	hl,LOAD_NAME
	call	FILE_LOAD

	ld	a,$ea		; ڃANZX[hɐݒ
	out	($c8),a

	jp	$9400


LOAD_NAME:
	db	"ipl   obj"

;
; ʃNAiLN^j
;
CURCLS:
	ld	hl,$f000
	ld	(hl),$20
	inc	hl
	ld	(hl),$0f
	inc	hl
	ld	de,$f000
	ex	de,hl
	ld	bc,40*25*2-1
	ldir
	ret

;
; fBXNG[
;
DISKERR:
	ld	de,DISKNG_MSG
	call	PNT_MSG
	jr	$

;
; RAM NG\
;
RAMNG:
	ld	a,$0e
	out	($6f),a		; 0xE000`0xFFFFRAM߂
	ld	de,RAMNG_MSG
	call	PNT_MSG
	jr	$

;
; \
;
PNT_MSG:
	push	bc
	ld	bc,(CUR_XY)
.lp1:
	ld	a,(de)
	inc	de
	or	a
	jr	z,.end
	cp	$0d
	jr	nz,.nom

	ld	c,0
	inc	b
	jr	.lp1
.nom:
	push	af
	push	bc

	ld	a,b
	add	a,a		; x2
	add	a,a		; x4
	add	a,b		; x5
	ld	l,a
	ld	h,0
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,hl		; x40
	add	hl,hl		; x80
	ld	b,$f0		; VRAMy[Wݒ
	add	hl,bc

	pop	bc
	pop	af
	ld	(hl),a
	inc	c
	inc	c

	ld	a,c
	cp	80
	jr	c,.lp1
	ld	c,0
	inc	b
	jr	.lp1

.end:
	ld	(CUR_XY),bc
	pop	bc
	ret

CUR_XY:	dw	$0000

VER_MSG:
	db	"ReFIGHT for P6 ver1.0",$0d,$0d,$00

DISKNG_MSG:
	db	"Disk error",$0d,$00


RAMNG_MSG:
	db	"64K ",H_i,H_si,"",H_yos,H_u,H_no,"RAM",H_ka," "
	db	H_hi,H_tu,H_yo,H_u,H_te,"",H_su,"",$0d,$00


;
; OPNɏo͂
; DFAhX
; EFf[^
;
OUTOPN:
	ld	a,d
	out	($a0),a

.lp1:	in	a,($a3)
	rlca
	jr	c,.lp1

	ld	a,e
	out	($a1),a

.lp2:	in	a,($a3)
	rlca
	jr	c,.lp2

	ret

;
; ԑ҂i 2ms ~ BCj
;
WAITTIME:
.lp1:	ld	a,$e2
.lp2:	dec	a
	nop
	jr	nz,.lp2

	dec	bc
	ld	a,b
	or	c
	jr	nz,.lp1
	ret

;
; ^Cg\
;
DISPTITLE:
	ld	a,$00			; 0x0000`0x1FFF̓ǂݏoVRAMɂ
	out	($60),a
	ld	a,$00			; 0x0000`0x1FFF݂̏VRAMɂ
	out	($68),a


	ld	hl,TITLEMSG1
	call	DISPMOJI

	ld	bc,100
	call	WAITTIME

	ld	hl,TITLEMSG2
	call	DISPMOJI

	ld	bc,700
	call	WAITTIME

	ld	hl,TITLEMSG6
	call	DISPMOJI

	ld	bc,2000
	call	WAITTIME

	jp	ACCMRAM

;
; Sp\
;
; HLFp[^擪AhX
;
DISPMOJI:
	ld	e,(hl)		; XW
	inc	hl
	ld	c,(hl)		; YW
	inc	hl
	ld	d,(hl)		; F
	inc	hl
	xor	a		; NOP
	bit	0,d
	jr	z,.c0
	ld	a,$77		; ld  (hl),a
.c0:
	ld	(.p00),a
	ld	(.p01),a
	ld	(.p02),a
	ld	(.p03),a

	xor	a		; NOP
	bit	1,d
	jr	z,.c1
	ld	a,$77		; ld  (hl),a
.c1:
	ld	(.p10),a
	ld	(.p11),a
	ld	(.p12),a
	ld	(.p13),a
	ld	b,(hl)		; 
	inc	hl

	ex	de,hl
	ld	h,$00
	add	hl,hl
	add	hl,hl		; VRAM擪

.lp1:
	push	de
	ex	de,hl
	ld	a,(hl)		; AhX
	inc	hl
	ld	h,(hl)		; AhX
	ld	l,a
	ex	de,hl

	call	READMOJI

	push	bc

	ld	b,16
	ld	de,MOJIBUF
.lp2:
	ld	a,b
	dec	a
	and	$03
	jr	z,.next

	ld	a,c
	out	($ce),a
	inc	c
.next:

	push	bc
	push	hl

	ld	a,(de)
	ld	b,a
	rrca
	rrca
	rrca
	rrca
	ld	c,a

	ld	a,b
	or	(hl)
.p00:	ld	(hl),a		; v[#0
	inc	l
	inc	l
	ld	a,b
	or	(hl)
.p10:	ld	(hl),a		; v[#1
	dec	l

	ld	a,c
	or	(hl)
.p01:	ld	(hl),a		; v[#0
	inc	l
	inc	l
	ld	a,c
	or	(hl)
.p11:	ld	(hl),a		; v[#1
	inc	l

	inc	de

	ld	a,(de)
	ld	b,a
	rrca
	rrca
	rrca
	rrca
	ld	c,a

	ld	a,b
	or	(hl)
.p02:	ld	(hl),a		; v[#0
	inc	l
	inc	l
	ld	a,b
	or	(hl)
.p12:	ld	(hl),a		; v[#1
	dec	l

	ld	a,c
	or	(hl)
.p03:	ld	(hl),a		; v[#0
	inc	l
	inc	l
	ld	a,c
	or	(hl)
.p13:	ld	(hl),a		; v[#1

	pop	hl
	inc	de

	pop	bc
	djnz	.lp2

	ld	bc,8
	add	hl,bc

	pop	bc
	pop	de
	inc	de
	inc	de
	djnz	.lp1

	ret

;
; Spf[^obt@ɓ]
; DEFR[h
; RETURN
; (MOJIBUF)F2*16oCgŃf[^i[
;
READMOJI:
	push	hl
	push	bc

	ld	a,d
	or	a
	jr	nz,.kanji

	ld	a,$d0		;0x4000`0x5FFF̓ǂݏoCGROM(0x0000`)ɂ
	out	($62),a
	ld	a,$d2		;0x6000`0x6FFF̓ǂݏoCGROM(0x2000`)ɂ
	out	($63),a

	ld	c,e
	ld	ix,MOJITABLE
	ld	b,(ix+0)	; e[u
	inc	ix

.mlp1:
	ld	a,(ix+1)	; 
	cp	c
	jr	c,.next

	ld	a,c
	sub	(ix+0)		; 
	jr	nc,.find
.next:
	ld	de,7
	add	ix,de
	djnz	.mlp1

	ld	a,c
	ld	hl,$1002+$4000
	cp	''
	jr	z,.wo

	ld	hl,$0fe2+$4000
	cp	''-$20
	jr	z,.wo

	jr	.spc


.find:
	ld	l,a
	ld	h,0
	ld	b,(ix+2)	; 搔
.mlp2:	add	hl,hl
	djnz	.mlp2

	ld	e,(ix+5)	; i[擪AhX
	ld	d,(ix+6)	; i[擪AhX

	add	hl,de
	ld	de,MOJIBUF

	ld	a,32		; ރf[^
.mlp4:
	ld	c,(ix+3)	; xɓǂݍރoCg
	ld	b,0
.mlp3:
	dec	a
	ldi
	jp	pe,.mlp3

	ex	af,af'
	ld	a,(ix+4)	; ̃f[^܂ł̃oCg
	add	a,l
	ld	l,a
	jr	nc,.noinc
	inc	h
.noinc:
	ex	af,af'
	or	a
	jr	nz,.mlp4

	pop	bc
	pop	hl
	ret


.kanji:
	sub	$80-$40
	ld	d,a
	push	de

	ld	a,$e8			;0x4000`0x5FFF̓ǂݏoROM(0x8000`)ɂ
	out	($62),a
	ld	a,$ea			;0x6000`0x6FFF̓ǂݏoROM(0xa000`)ɂ
	out	($63),a

	ld	bc,$10ff
	ld	hl,MOJIBUF
	ex	de,hl
.klp1:
	ldi
	inc	de
	djnz	.klp1

	pop	de

	ld	a,$ec			;0x4000`0x5FFF̓ǂݏoROM(0xc000`)ɂ
	out	($62),a
	ld	a,$ee			;0x6000`0x6FFF̓ǂݏoROM(0xe000`)ɂ
	out	($63),a

	ld	bc,$10ff
	ld	hl,MOJIBUF+1
	ex	de,hl
.klp2:
	ldi
	inc	de
	djnz	.klp2

	pop	bc
	pop	hl
	ret

.wo:
	ld	a,$f8			;0x4000`0x5FFF̓ǂݏoBASIC-ROM(0x0000`)ɂ
	out	($62),a
	ld	a,$fa			;0x6000`0x7FFF̓ǂݏoBASIC-ROM(0x0000`)ɂ
	out	($63),a

	ld	de,MOJIBUF
	ld	bc,32
	ldir

	pop	bc
	pop	hl
	ret

.spc:
	xor	a
	ld	b,32
	ld	hl,MOJIBUF
.slp1:
	ld	(hl),a
	inc	hl
	djnz	.slp1

	pop	bc
	pop	hl
	ret

.end:
	pop	bc
	pop	hl
	ret

;
; 񊿎i[ꏊȂ
;
MOJITABLE:
	db	5	; e[u

			; 0x21-0x3F
	db	$21	; ŏ̕
	db	$3f	; Ō̕
	db	$07	; ̕܂ł̃oCg̏搔
	db	$04	; xɓǂݍރoCg
	db	$10-$04	; ̃f[^܂ł̃oCg
	dw	$408c	; ŏ̊̕i[擪AhX

			; 0x40-0x7F
	db	$40	; ŏ̕
	db	$7f	; Ō̕
	db	$06	; ̕܂ł̃oCg̏搔
	db	$08	; xɓǂݍރoCg
	db	$10-$08	; ̃f[^܂ł̃oCg
	dw	$5008	; ŏ̊̕i[擪AhX

			; 0x90-0x9F
	db	$90	; ŏ̕
	db	$9f	; Ō̕
	db	$08	; ̕܂ł̃oCg̏搔
	db	$02	; xɓǂݍރoCg
	db	$10-$02	; ̃f[^܂ł̃oCg
	dw	$700a	; ŏ̊̕i[擪AhX

			; 0xB1-0xBF
	db	$b0	; ŏ̕
	db	$bf	; Ō̕
	db	$08	; ̕܂ł̃oCg̏搔
	db	$02	; xɓǂݍރoCg
	db	$10-$02	; ̃f[^܂ł̃oCg
	dw	$600a	; ŏ̊̕i[擪AhX

			; 0xC0-0xFF
	db	$c0	; ŏ̕
	db	$ff	; Ō̕
	db	$07	; ̕܂ł̃oCg̏搔
	db	$04	; xɓǂݍރoCg
	db	$10-$04	; ̃f[^܂ł̃oCg
	dw	$600c	; ŏ̊̕i[擪AhX

;
; \
;
TITLEMSG1:
	db	30			; XW(/8)
	db	76			; YW
	db	4-1			; F
	db	(.ed+2-.st)/2		; 
.st:	dw	'R'			; AhX
	dw	'E'			; AhX
	dw	'F'			; AhX
	dw	'I'			; AhX
	dw	'G'			; AhX
	dw	'H'			; AhX
.ed:	dw	'T'			; AhX

TITLEMSG2:
	db	18			; XW(/8)
	db	100			; YW
	db	4-1			; F
	db	(.ed+2-.st)/2		; 
.st:	dw	'P'			; AhX
	dw	'r'			; AhX
	dw	'e'			; AhX
	dw	's'			; AhX
	dw	'e'			; AhX
	dw	'n'			; AhX
	dw	't'			; AhX
	dw	'e'			; AhX
	dw	'd'			; AhX
	dw	' '			; AhX
	dw	'b'			; AhX
	dw	'y'			; AhX
	dw	' '			; AhX
	dw	'G'			; AhX
	dw	'r'			; AhX
	dw	'o'			; AhX
	dw	'u'			; AhX
	dw	'p'			; AhX
	dw	' '			; AhX
	dw	'R'			; AhX
	dw	'2'			; AhX
	dw	'0'			; AhX
.ed:	dw	'4'			; AhX

TITLEMSG6:
	db	22			; XW(/8)
	db	180			; YW
	db	4-1			; F
	db	(.ed+2-.st)/2		; 
.st:	dw	''			; AhX
	dw	''			; AhX
	dw	''			; AhX
	dw	''-$20			; AhX
	dw	$8000+16*(380-1)	; AhX"g"
	dw	$8000+16*(970-1)	; AhX"p"
	dw	$8000+16*(687-1)	; AhX""
	dw	''+$20			; AhX
	dw	$8000+16*(902-1)	; AhX""
	dw	''+$20			; AhX
	dw	$8000+16*(446-1)	; AhX""
	dw	$8000+16*(102-1)	; AhX"O"
	dw	''-$20			; AhX
	dw	''+$20			; AhX
	dw	$8000+16*(66-1)		; AhX""
	dw	''-$20			; AhX
	dw	''-$20			; AhX
.ed:	dw	''			; AhX


;
; \pobt@2*16oCg
; ï͊mۂȂj
;
MOJIBUF:



	org	$c500
;
; Track#0 Sector#6-8
;

	phase	Disk_Routine

	include	"disk66.z80"	; hCupǂݏo[`

	dephase


	org	$c800
;
; Track#0 Sector#9-11
;

	phase	Disk_Routine

	include	"disk.z80"	; OthCupǂݏo[`

	dephase


	org	$caff
	db	$ff


end

