;
; gameppb`
;

	relaxed on

KEYDATA		equ	$8727
GAMEDATA	equ	$8728	; "0" STOP SFT SPC E
CAPSDATA	equ	$872d
GAMESTART	equ	$f000
SP_STORE	equ	$f006

; b500-b7ff
; ǉvO
;
	org	$b500

;
; 0x0000`0x7FFF݂̏RAMɂ
;
ACCVRAM:
	push	af
	xor	a
.cnt:
	out	($68),a
	add	a,2
	out	($69),a
	add	a,2
	out	($6a),a
	add	a,2
	out	($6b),a
	pop	af
	ret

;
; 0x0000`0x7FFF݂̏ORAMɂ
;
ACCMRAM:
	push	af
	ld	a,$20
	jr	ACCVRAM.cnt

;
; 0x0000`0x7FFF̓ǂݏoRAMɂ
;
ACCVRAM_R:
	push	af
	xor	a
.cnt:
	out	($60),a
	add	a,2
	out	($61),a
	add	a,2
	out	($62),a
	add	a,2
	out	($63),a
	pop	af
	ret

;
; 0x0000`0x7FFF̓ǂݏoORAMɂ
;
ACCMRAM_R:
	push	af
	ld	a,$20
	jr	ACCVRAM_R.cnt


; 88P6AhXϊi͈͐tj
; 88VRAḾAYWS̔{O
; ͈͊O͍lȂ
;
; ($be8d)F88-VRAMAhX
; RETURNF
; DEFVRAMAhX
;
CONV_88TOP6:
	ld	de,($be8d)
.n1:
	push	hl

	ld	a,$0c		; 0xC000-0xDFFF̓ǂݏoRAMɂ
	out	($66),a

	ld	h,$c1
	ld	l,d
	ld	a,(hl)		; Zl
	dec	h
	ld	h,(hl)		; e[uʃAhX

	ld	l,e

	ld	e,(hl)
	inc	h
	inc	h
	inc	h
	inc	h
	inc	h
	ld	d,(hl)
	add	a,d
	ld	d,a

	ld	a,$2c		; 0xC000-0xDFFF̓ǂݏoORAMɂ
	out	($66),a

	pop	hl
	ret


; 32x16hbg`̓A24x16hbg`i͈͐tj
; DEF88-VRAMAhX
; HLFp^[AhX
;
DRAW32x16_24:
	inc	d
	ret	c
	dec	d
	ld	bc,ACCMRAM
	push	bc
	call	CONV_88TOP6.n1
	call	ACCVRAM
	ld	iyl,8
	dec	d
.lp1:
	inc	d
	ret	m
	ld	a,d
	cp	$1a
	ld	bc,16
	jr	c,.udf

	ld	a,e
	REPT	12
	ldi
	ENDM
	ld	e,a

.udf:
	add	hl,bc
	dec	iyl
	jr	nz,.lp1
	ret

; 32x16hbg`̓A16x16hbg`i͈͐tj
; DEF88-VRAMAhX
; HLFp^[AhX
;
DRAW32x16_16:
	inc	d
	ret	c
	dec	d
	ld	bc,ACCMRAM
	push	bc
	call	CONV_88TOP6.n1
	call	ACCVRAM
	ld	iyl,8
	dec	d
.lp1:
	inc	d
	ret	m
	ld	a,d
	cp	$1a
	ld	bc,16
	jr	c,.udf

	ld	a,e
	REPT	8
	ldi
	ENDM
	ld	e,a

.udf:
	add	hl,bc
	dec	iyl
	jr	nz,.lp1
	ret

; 32x16hbg`̓A8x16hbg`i͈͐tj
; DEF88-VRAMAhX
; HLFp^[AhX
;
DRAW32x16_8:
	inc	d
	ret	c
	dec	d
	ld	bc,ACCMRAM
	push	bc
	call	CONV_88TOP6.n1
	call	ACCVRAM
	ld	iyl,8
	dec	d
.lp1:
	inc	d
	ret	m
	ld	a,d
	cp	$1a
	ld	bc,16
	jr	c,.udf

	ld	a,e
	REPT	4
	ldi
	ENDM
	ld	e,a

.udf:
	add	hl,bc
	dec	iyl
	jr	nz,.lp1
	ret

; 16x16hbg`i͈͐tFj
; DEF88-VRAM
; HLFp^[AhX
;
DRAW16x16:
	call	CONV_88TOP6.n1
	call	ACCVRAM
	ld	bc,$08ff
.lp1:
	ld	a,e
	REPT	8
	ldi
	ENDM
	ld	e,a
	inc	d

	djnz	.lp1
	jp	ACCMRAM

;
; 8xBreghbg̏i8x16hbgj
; HLF88-VRAM
; B Fchbg
;
ERASE8xB:
	ex	de,hl
	ld	hl,ACCMRAM
	push	hl
	call	CONV_88TOP6.n1
	call	ACCVRAM
	srl	b
	xor	a
	dec	d
.lp1:
	inc	d
	ret	m

	ld	c,e
	REPT	3
	ld	(de),a
	inc	e
	ENDM
	ld	(de),a
	ld	e,c

	djnz	.lp1
	ret

; VRAMAhXiEjZo
; BFYW/4i0`49j
; CFXWi0`79j
; RETURN
; HLFVRAMAhX
; ZflagF1̎AX=63
; CflagF1̎AX=0-62
;
CALCVRAM_R:
	ld	a,b

	rrca
	rrca				; Y5-0 => Y1-0,,Y5-2
	and	$c0			; Y1-0 => b7,6
	ld	e,a

	ld	a,c
	add	a,a
	add	a,a
	add	a,e
	ld	e,a

	ld	a,b
	rrca				; Y0,,Y5-1
	and	$1e			; Y5-2 => b4-1
	ld	d,a

	ld	a,c
	cp	63
	ret

;
; 16x8hbgiEj
;
DRAW16x8_R:
	jr	z,DRAW16x8_LR
	ld	bc,$02ff
.lp1:
	ld	a,e

	REPT	8
	ldi
	ENDM
	dec	de

	ld	e,a
	inc	d

	REPT	8
	ldi
	ENDM
	dec	de
	dec	d

	add	a,$40
	ld	e,a
	jr	nc,.n1
	inc	d
	inc	d
.n1:

	djnz	.lp1
	jp	ACCMRAM
;
; 16x8hbgiX=63̎j
;
DRAW16x8_LR:
	ld	bc,$04ff
.lp1:
	ld	a,e
	REPT	4
	ldi
	ENDM
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	ld	e,a
	djnz	.lp1

	dec	d
	dec	d
	dec	d
	dec	d
	call	CALCVRAM_L2R

	ld	bc,-28
	add	hl,bc

	ld	bc,$02ff
.lp2:
	ld	a,e
	REPT	4
	ldi
	ENDM
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	ld	e,a
	inc	d

	REPT	4
	ldi
	ENDM
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	dec	d

	add	a,$40
	ld	e,a
	jr	nc,.n1
	inc	d
	inc	d
.n1:
	djnz	.lp2
	jp	ACCMRAM

;
; VRAMAhXEZo
; DFVRAMAhX
; DEFVRAMEAhX
;
CALCVRAM_L2R:
	ld	a,d
	sub	$1a
	srl	a
	ld	d,a

	rrca
	rrca				; Y5-0 => Y1-0,,Y5-2
	and	$c0			; Y1-0 => b7,6
	ld	e,a

	ld	a,d
	rrca				; Y0,,Y5-1
	and	$1e			; Y5-2 => b4-1
	ld	d,a

	ret

; 
; EXN[ij
;
WINSCR_CNT:
	ld	b,7
	ld	hl,$1440
	ld	de,$12c0
.lp1:
	push	bc

	push	de
	push	hl
	ld	bc,60
	ldir
	pop	hl
	pop	de
	inc	h
	inc	d

	ld	c,60		; b=0
	ldir
	dec	h
	dec	d

	ld	a,e
	add	a,4
	ld	e,a
	jr	nc,.n1
	inc	d
	inc	d
.n1:

	ld	a,l
	add	a,4
	ld	l,a
	jr	nc,.n2
	inc	h
	inc	h
.n2:
	pop	bc
	djnz	.lp1

	call	ACCMRAM
	jp	ACCMRAM_R

;
; Ge\i4x2hbgj
;
DRAW4x2:
	ld	a,$e2		; rbg}bv[hɐݒ
	out	($c8),a

	xor	a
	out	($68),a

	ld	a,($d46b)	; YW
	out	($ce),a
	ld	hl,($d469)	; XW
	ld	(hl),e
	inc	l
	inc	l
	ld	(hl),e
	inc	a
	out	($ce),a
	ld	(hl),e
	dec	l
	dec	l
	ld	(hl),e

	ld	a,$20
	out	($68),a

	ld	a,$ea		; ڃANZX[hɐݒ
	out	($c8),a

	ret

;
; pbgݒ
;
SETPALET_B:
	ld	a,$0f!$08	; pbgݒi"00"=j
	out	($43),a	
	ret

;
; Q[X^[g
;
START:
	ld	(SP_STORE),sp
	jp	$beaa

; b800-b802
; Q[X^[g
;
	org	$b800
	jp	START

; b803-
; ̂܂܎gp
;
	org	$b803
	db	$ff

; b845-b847
; 32x16hbg`i͈͐tj
;
	org	$b845
	jp	c,DRAW32x16_LEFT

; b848-
; ̂܂܎gp
;
	org	$b848
	db	$ff

; b84a-b84c
; 32x16hbg`i͈͐tj
;
	org	$b84a
	jp	nc,DRAW32x16_RIGHT

; b84d-
; ̂܂܎gp
;
	org	$b84d
	db	$ff

; b850-b852
; 32x16hbg`i͈͐tj
;
	org	$b850
	jp	c,DRAW32x16_UD

; b853-
; ̂܂܎gp
;
	org	$b853
	db	$ff

; b855-b857
; 32x16hbg`i͈͐tj
;
	org	$b855
	jp	nc,DRAW32x16_UD

; b858-
; ̂܂܎gp
;
	org	$b858
	db	$ff

; b85f-b884
; 32x16hbg`i͈͐tj
;
	org	$b85f
	jp	nz,DRAW32x16
	jp	DRAW32x16_W

; b885-
; ̂܂܎gp
;
	org	$b885
	db	$ff

; b89a-b89b
; 32x16hbg`i͈͐tj
;
	org	$b89a
	jr	c,DRAW32x16_LEFT

; b89c-
; ̂܂܎gp
;
	org	$b89c
	db	$ff

; b89e-b8a0
; 32x16hbg`i͈͐tj
;
	org	$b89e
	jp	nc,DRAW32x16_RIGHT

; b8a1-
; ̂܂܎gp
;
	org	$b8a1
	db	$ff

; b8a4-b8a6
; 32x16hbg`i͈͐tj
;
	org	$b8a4
	jp	c,DRAW32x16_UD

; b8a7-
; ̂܂܎gp
;
	org	$b8a7
	db	$ff

; b8a9-b9ea
; 32x16hbg`i͈͐tj
;
	org	$b8a9
	jp	nc,DRAW32x16_UD

; 32x16hbg`i͈͐tj
; ($be8d)F88-VRAMAhX
; HLFp^[AhX
;
DRAW32x16:
	call	CONV_88TOP6
	call	ACCVRAM
	ld	bc,$08ff
.lp1:
	ld	a,e
	REPT	16
	ldi
	ENDM
	ld	e,a

	inc	d
	djnz	.lp1
	jp	ACCMRAM

; 32x16hbg`i͈͐tj
; ͈͊OΉij
;
DRAW32x16_LEFT:
	sub	$1f
	jr	nz,.n1
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	inc	de
	jp	DRAW32x16_24

.n1:	inc	a
	jr	nz,.n2
	ld	bc,8
	add	hl,bc
	inc	de
	inc	de
	jp	DRAW32x16_16

.n2:	inc	a
	ret	nz
	ld	bc,12
	add	hl,bc
	inc	de
	inc	de
	inc	de
	jp	DRAW32x16_8

; 32x16hbg`i͈͐tj
; ͈͊OΉiEj
;
DRAW32x16_RIGHT:
	sub	$49
	jp	z,DRAW32x16_24
	dec	a
	jp	z,DRAW32x16_16
	dec	a
	jp	z,DRAW32x16_8
	ret

; 32x16hbg`̓A32x4/8/12hbg`i͈͐tj
; ($be8d)F88-VRAMAhX
; HLFp^[AhX
;
DRAW32x16_UD:
	ld	bc,ACCMRAM
	push	bc
	call	CONV_88TOP6
	call	ACCVRAM
	ld	iyl,8
	dec	d
.lp1:
	inc	d
	ret	m
	ld	a,d
	cp	$1a
	jr	c,.udf

	ld	a,e
	REPT	16
	ldi
	ENDM
	ld	e,a
	dec	iyl
	jr	nz,.lp1
	ret

.udf:
	ld	bc,16
	add	hl,bc
	dec	iyl
	jr	nz,.lp1
	ret

; 32x16hbg`iŕ`ji͈͐tj
; ($be8d)F88-VRAMAhX
; HLFp^[AhX
;
DRAW32x16_W:
	call	CONV_88TOP6
	call	ACCVRAM
	ld	b,$08
.lp1:
	ld	c,e

	REPT	7
	ld	a,(hl)
	inc	hl
	or	(hl)
	inc	hl
	ld	(de),a
	inc	e
	ld	(de),a
	inc	e
	ENDM

	ld	a,(hl)
	inc	hl
	or	(hl)
	inc	hl
	ld	(de),a
	inc	e
	ld	(de),a

	ld	e,c
	inc	d
	djnz	.lp1
	jp	ACCMRAM

; b9eb-baac
; 32x4hbgi͈͐tj
; HLF88-VRAMAhX
; A FXW
;
	org	$b9eb
	push	bc
	call	ERASE32x4
	pop	bc
	ret

ERASE32x4:
	ex	af,af'
	ld	a,h
	inc	a
	ret	z

	ld	a,h
	cp	$c0
	ret	c

	ld	b,2
.cnt:
	ex	af,af'
	cp	$20
	jp	c,ERASE32x4_LEFT
	cp	$49
	jp	nc,ERASE32x4_RIGHT

	ex	de,hl
	ld	hl,ACCMRAM		; ߂
	push	hl
	call	CONV_88TOP6.n1
	call	ACCVRAM

	xor	a
	dec	d
.lp1:
	inc	d
	ret	m

	ld	c,e
	REPT	15
	ld	(de),a
	inc	e
	ENDM
	ld	(de),a
	ld	e,c

	djnz	.lp1
	ret

; 32x4hbgi͈͐tj
; ͈͊OΉij
;
ERASE32x4_LEFT:
	sub	$1f
	jr	nz,.n1
	inc	hl
	jp	ERASE32x4_24

.n1:	inc	a
	jr	nz,.n2
	inc	hl
	inc	hl
	jp	ERASE32x4_16

.n2:	inc	a
	ret	nz
	inc	hl
	inc	hl
	inc	hl
	jp	ERASE32x4_8

; 32x4hbgi͈͐tj
; ͈͊OΉiEj
;
ERASE32x4_RIGHT:
	sub	$49
	jp	z,ERASE32x4_24
	dec	a
	jp	z,ERASE32x4_16
	dec	a
	jp	z,ERASE32x4_8
	ret

; baad-
; ̂܂܎gp
;
	org	$baad
	db	$ff

; bab9-bb15
; 8x16hbgi͈͐tj
; HLF88-VRAMAhX
;
	org	$bab9
	push	bc
	call	ERASE8x16
	pop	bc
	ret

ERASE8x16:
	ld	de,320
	ld	b,4
.lp2:
	ld	a,h
	cp	$c0
	jp	nc,.n1
	dec	b
	ret	z
	add	hl,de
	jp	.lp2
.n1:
	ex	de,hl
	ld	hl,ACCMRAM		; ߂
	push	hl
	call	CONV_88TOP6.n1
	call	ACCVRAM

	sla	b
	xor	a
	dec	d
.lp1:
	inc	d
	ret	m
	ld	c,e
	ld	(de),a
	inc	e
	ld	(de),a
	inc	e
	ld	(de),a
	inc	e
	ld	(de),a

	ld	e,c
	djnz	.lp1
	ret

; bb16-
; ̂܂܎gp
;
	org	$bb16
	db	$ff

; bb29-bb9c
; 32xBreghbgi͈͐tj
; HLFVRAMAhX
; A'FXW
; B Fchbg
;
	org	$bb29
ERASE32xB:
	srl	b
	jp	ERASE32x4.cnt

;
; 32x4hbg̓A24x4hbgi͈͐tj
;
ERASE32x4_24:
	ex	de,hl
	ld	hl,ACCMRAM		; ߂
	push	hl
	call	CONV_88TOP6.n1
	call	ACCVRAM

	xor	a
	dec	d
.lp1:
	inc	d
	ret	m

	ld	c,e
	REPT	11
	ld	(de),a
	inc	e
	ENDM
	ld	(de),a
	ld	e,c

	djnz	.lp1
	ret

;
; 32x4hbg̓A16x4hbgi͈͐tj
;
ERASE32x4_16:
	ex	de,hl
	ld	hl,ACCMRAM		; ߂
	push	hl
	call	CONV_88TOP6.n1
	call	ACCVRAM

	xor	a
	dec	d
.lp1:
	inc	d
	ret	m

	ld	c,e
	REPT	7
	ld	(de),a
	inc	e
	ENDM
	ld	(de),a
	ld	e,c

	djnz	.lp1
	ret

;
; 32x4hbg̓A8x4hbgi͈͐tj
;
ERASE32x4_8:
	ex	de,hl
	ld	hl,ACCMRAM		; ߂
	push	hl
	call	CONV_88TOP6.n1
	call	ACCVRAM

	xor	a
	dec	d
.lp1:
	inc	d
	ret	m

	ld	c,e
	REPT	3
	ld	(de),a
	inc	e
	ENDM
	ld	(de),a
	ld	e,c

	djnz	.lp1
	ret

; bb9d-
; ̂܂܎gp
;
	org	$bb9d
	db	$ff

; bba5-bba6
; 16x16hbgi͈͐tj
;
	org	$bba5
	jr	z,ERASE16x16_LEFT

; bba7-
; ̂܂܎gp
;
	org	$bba7
	db	$ff

; bbaa-bbac
; 16x16hbgi͈͐tj
;
	org	$bbaa
	jp	z,ERASE8x16

; bbad-
; ̂܂܎gp
;
	org	$bbad
	db	$ff

; bbae-bbf0
; 16x16hbgi͈͐tj
;
	org	$bbae
ERASE16x16:
	ld	de,320
	ld	b,4
.lp2:
	ld	a,h
	cp	$c0
	jp	nc,.n1
	dec	b
	ret	z
	add	hl,de
	jp	.lp2
.n1:
	ex	de,hl
	ld	hl,ACCMRAM		; ߂
	push	hl
	call	CONV_88TOP6.n1
	call	ACCVRAM

	sla	b
	xor	a
	dec	d
.lp1:
	inc	d
	ret	m

	ld	c,e
	REPT	7
	ld	(de),a
	inc	e
	ENDM
	ld	(de),a
	ld	e,c

	djnz	.lp1
	ret

ERASE16x16_LEFT:
	inc	hl
	jp	ERASE8x16

; bbf1-bc07
; ANZX[hݒ
;
	org	$bbf1
	jr	$

; bc08-
; ̂܂܎gp
;
	org	$bc08
	db	$ff

; bc69-bc95
; 16x8hbg`
; BFYW/4i0`49j
; CFXWi0`79j
; AFp^[ԍ
;
	org	$bc69
	add	a,a		; x2
	add	a,a		; x4
	ld	h,0
	ld	l,a
	add	hl,hl		; x8
	add	hl,hl		; x16
	add	hl,hl		; x32
	call	CALCVRAM
	call	ACCVRAM
	jp	nc,DRAW16x8_R

DRAW16x8_L:
	ld	bc,$04ff
.lp1:
	ld	a,e

	REPT	8
	ldi
	ENDM

	dec	de
	ld	e,a
	inc	d
	djnz	.lp1
	jp	ACCMRAM

; bc96-
; ̂܂܎gp
;
	org	$bc96
	db	$ff

; bcc8-bcf3
; ~TC\i8x16hbgj
;
	org	$bcc8
DRAW8x16:
	ld	a,h
	cp	$c0
	ret	c

	ex	de,hl
	ld	hl,ACCMRAM
	push	hl
	call	CONV_88TOP6.n1
	call	ACCVRAM

	ld	hl,$8c60
	ld	bc,$08ff
	dec	d
.lp1:
	inc	d
	ret	m

	ld	a,e
	REPT	4
	ldi
	ENDM
	ld	e,a
	djnz	.lp1
	ret

; bcf4-
; ̂܂܎gp
;
	org	$bcf4
	db	$ff

; bcf8-bd0d
; 8xBreghbg̏i8x16hbgj
;
	org	$bcf8
	jp	ERASE8xB

; bd0e-bdeb
; `
;
	org	$bd0e
	ld	a,$e2		; rbg}bv[hɐݒ
	out	($c8),a
	xor	a
	out	($60),a		; 0x0000-0x1fff̓ǂݏRAMɂ
	out	($68),a		; 0x0000-0x1fff̓ǂݏRAMɂ

	ld	hl,STARDATA
	ld	c,3
	call	STARMOVE
	ld	c,2
	call	STARMOVE
	ld	c,1
	call	STARMOVE
	ld	c,1
	call	STARMOVE

	ld	a,$20
	out	($60),a		; 0x0000-0x1fff̓ǂݏORAMɖ߂
	out	($68),a		; 0x0000-0x1fff̓ǂݏORAMɖ߂
	ld	a,$ea		; ڃANZX[hɐݒ
	out	($c8),a

	ret

;
; 𓮂
; HLFe[u|C^
; C FY
;
STARMOVE:
	ld	a,6
.lp1:
	ex	af,af'
	ld	e,(hl)		; OXW
	ld	d,0
	inc	hl
	ld	a,(hl)		; OYW
	out	($ce),a
	inc	hl
	ld	b,(hl)		; ̐F
	ex	de,hl

	res	3,(hl)		; O̐
	inc	l
	inc	l
	res	3,(hl)		; O̐

	add	a,c
	cp	200
	jp	c,.n1

	ld	a,r
	and	$03
	ld	b,a
	ld	(de),a		; ̐FV

	xor	a		; VYW
.n1:
	out	($ce),a
	dec	de
	ld	(de),a		; VYW

	bit	1,b
	jr	z,.n2
	set	3,(hl)		; `
.n2:
	dec	l
	dec	l

	bit	0,b
	jr	z,.n3
	set	3,(hl)		; `
.n3:

	ex	de,hl
	inc	hl
	inc	hl

	ex	af,af'
	dec	a
	jp	nz,.lp1
	ret


STARDATA:	; X    Y    C

	db	$80, $64, $01
	db	$58, $32, $02
	db	$b4, $4d, $03
	db	$e4, $9f, $01
	db	$cc, $14, $02
	db	$70, $b0, $03
	db	$64, $00, $03
	db	$dc, $50, $02
	db	$b4, $a0, $01
	db	$80, $78, $03
	db	$70, $b4, $02
	db	$98, $63, $01
	db	$78, $87, $03
	db	$e0, $4d, $01
	db	$60, $43, $02
	db	$94, $a3, $03
	db	$a4, $14, $01
	db	$c0, $b4, $02
	db	$68, $80, $02
	db	$84, $a8, $01
	db	$9c, $0f, $03
	db	$c4, $23, $02
	db	$d4, $55, $01
	db	$e4, $af, $03


; bdec-be0a
; 8x4hbg`
; DEFp^[AhX
; HLF88-VRAMAhX
;
	org	$bdec
DRAW8x4:
	call	ACCVRAM
	ex	de,hl
	call	CONV_88TOP6.n1

	ld	a,e
	ldi
	ldi
	ldi
	ldi
	ld	e,a
	inc	d

	ldi
	ldi
	ldi
	ldi

	jp	ACCMRAM

; be0b-be34
; 16x16hbg̃p^[\i͈͐tj
;
	org	$be0b
	cp	$20-1
	ret	c
	cp	$4b-1
	ret	nc
	ld	a,d
	cp	$c0
	ret	c
	cp	$f9
	ret	nc

	jp	DRAW16x16

; be35-be52
; 16x16hbg̏i͈͐tj
;
	org	$be35
	cp	$20-1
	ret	c
	cp	$4b-1
	ret	nc
	ld	b,4
	jp	ERASE16x16.n1

; be53-be77
; EXN[
;
	org	$be53
WINSCR:
	call	ACCVRAM
	call	ACCVRAM_R

	ld	bc,14*$0100 + $ff

	ld	h,$6c
	ld	d,$68
	ld	a,$fc

.lp1:
	ld	l,a
	ld	e,a
	ldi
	ldi
	ldi
	ldi

	djnz	.lp1

	jp	WINSCR_CNT

; be78-be8c
; VRAMAhXZo
; BFYW/4i0`49j
; CFXWi0`79j
; RETURN
; DEFVRAMAhX
; ZflagF1̎AX=63
; CflagF1̎AX=0-62
;
	org	$be78
CALCVRAM:
	bit	6,c
	jp	nz,CALCVRAM_R

CALCVRAM_L:
	ld	a,b
	add	a,a
	add	a,$1a
	ld	d,a
	ld	a,c
	add	a,a
	add	a,a
	ld	e,a
	ld	a,c
	cp	63
	ret

; be8d-
; ̂܂܎gp
;
	org	$be8d
	db	$ff

; bee6-beed
; Jn̖ʑI
;
	org	$bee6
	ld	a,(KEYDATA)
	sub	'A'
	jr	c,$bef2
	inc	a

; beee-
; ̂܂܎gp
;
	org	$beee
	db	$ff

; bf1b-bf1e
; nCXRAǂݏo
;
	org	$bf1b
	ld	d,0
	ld	e,16

; bf1f-
; ̂܂܎gp
;
	org	$bf1f
	db	$ff

; bf32-bf38
; x
;
	org	$bf32
	ld	a,$05		; xp
	jr	$bf39

; bf39-
; ̂܂܎gp
;
	org	$bf39
	db	$ff

; bf3c-bf42
; VRAM֘A
;
	org	$bf3c
	jr	$bf43

; bf43-
; ̂܂܎gp
;
	org	$bf43
	db	$ff

; bf90-bf93
; pbgݒ
;
	org	$bf90
	ld	a,$0f!$0a	; pbgݒi"00"=ԁj
	out	($43),a	

; bf94-
; ̂܂܎gp
;
	org	$bf94
	db	$ff

; c081-c083
; ʃNAf
;
	org	$c081
	ld	hl,-320

; c084-
; ̂܂܎gp
;
	org	$c084
	db	$ff

; c087-c08a
; ʃNAf
;
	org	$c087
	ld	c,4
	ld	b,6

; c08b-
; ̂܂܎gp
;
	org	$c08b
	db	$ff

; c0e0-c0e2
; ʃNAf
;
	org	$c0e0
	ld	de,-320

; c0e3-
; ̂܂܎gp
;
	org	$c0e3
	db	$ff

; c15b-c15e
; pbgݒ
;
	org	$c15b
	jp	SETPALET_B

; c15f-
; ̂܂܎gp
;
	org	$c15f
	db	$ff

; c23b-c241
; I
;
	org	$c23b
	ld	a,(KEYDATA)
	sub	'A'
	jr	c,$c24a

; c242-
; ̂܂܎gp
;
	org	$c242
	db	$ff

; c36e-c38e
; PAUSE
;
	org	$c36e
PAUSEWAIT:
	ld	a,(KEYDATA)
	cp	$1b		; ESC
	jr	nz,$c38f

.lp1:
	ld	a,(GAMEDATA)
	and	$10
	jr	z,.lp1
	jr	$c38f

; c38f-
; ̂܂܎gp
;
	org	$c38f
	db	$ff

; c39a-c39b
; x
;
	org	$c39a
;	ld	b,$5a		; xp
	ld	b,$2d		; xp
;	ld	b,$01		; xp

; c39c-
; ̂܂܎gp
;
	org	$c39c
	db	$ff

; c533-c536
; eLXgECh
;
	org	$c533
	jr	$c537

; c537-
; ̂܂܎gp
;
	org	$c537
	db	$ff

; ca86-ca89
; VRAM֘A
;
	org	$ca86
	jp	(hl)

; ca8a-
; ̂܂܎gp
;
	org	$ca8a
	db	$ff

; cab2-cab4
; VRAM֘A
;
	org	$cab2
	jr	$cab5

; cab5-
; ̂܂܎gp
;
	org	$cab5
	db	$ff

; cbf6-cc03
; G@ړ
;
	org	$cbf6
	push	hl
	call	z,$bb16
	jp	$cbca

; cc04-
; ̂܂܎gp
;
	org	$cc04
	db	$ff

; cd40-cd41
; BEEP炷Ȃ
;
	org	$cd40
	nop
	nop

; cd42-
; ̂܂܎gp
;
	org	$cd42
	db	$ff

; cd80-cd81
; BEEP~߂遨Ȃ
;
	org	$cd80
	nop
	nop

; cd82-
; ̂܂܎gp
;
	org	$cd82
	db	$ff

; cda2-cda3
; BEEP炷Ȃ
;
	org	$cda2
	nop
	nop

; cda4-
; ̂܂܎gp
;
	org	$cda4
	db	$ff

; cdcf-cdd0
; BEEP~߂遨Ȃ
;
	org	$cdcf
	nop
	nop

; cdd1-
; ̂܂܎gp
;
	org	$cdd1
	db	$ff

; cde8-cde9
; BEEP~߂遨Ȃ
;
	org	$cde8
	nop
	nop

; cdea-
; ̂܂܎gp
;
	org	$cdea
	db	$ff

; cf1a-cf34
; eLXgVRAM֘A
;
	org	$cf1a
	ret

; cf35-
; ̂܂܎gp
;
	org	$cf35
	db	$ff

; cf9a-cfaa
; Ge
;
	org	$cf9a
	ld	e,$00		; Ge̐F
	call	DRAW4x2		; Ge\
	jr	$cfab

; cfab-
; ̂܂܎gp
;
	org	$cfab
	db	$ff

; cfc2-cfd1
; Ge`
;
	org	$cfc2
	ld	e,$0f		; Ge̐F
	call	DRAW4x2		; Ge\
	jr	$cfd2

; cfd2-
; ̂܂܎gp
;
	org	$cfd2
	db	$ff

; d1af-d1e2
; XYWGeVRAMAhXZo
;($d467)FX+28Wi0`159j
;($d468)FY+64Wi0`99j
; RETURN
;($d469)FXW
;($d46b)FYW
;
	org	$d1af
	push	hl
	ld	a,($d467)
	sub	28

	ld	h,a
	and	$fe
	rrc	h
	ccf
	ld	l,a
	ld	h,0
	adc	hl,hl		; x2+c
	ld	($d469),hl
	ld	a,($d468)
	sub	64
	add	a,a
	ld	($d46b),a
	pop	hl
	ret

; d1e3-
; ̂܂܎gp
;
	org	$d1e3
	db	$ff

; d1ee-d1f2
; Ge
;
	org	$d1ee
	ld	e,$00		; Ge̐F
	call	DRAW4x2		; Ge\

; d1f3-
; ̂܂܎gp
;
	org	$d1f3
	db	$ff

; d4c2-d4c5
; pbgݒ
;
	org	$d4c2
	ld	a,$0f!$0e	; pbgݒi"00"=j
	out	($43),a	

; d4c6-
; ̂܂܎gp
;
	org	$d4c6
	db	$ff

; d4c7-d4ca
; pbgݒ
;
	org	$d4c7
	ld	a,$0f!$0f	; pbgݒi"00"=j
	out	($43),a	

; d4cb-
; ̂܂܎gp
;
	org	$d4cb
	db	$ff

; d525-d52b
; VRAM֘A
;
	org	$d525
	jr	$d52c

; d52c-
; ̂܂܎gp
;
	org	$d52c
	db	$ff

; d54e-d551
; VRAM֘A
;
	org	$d54e
	ret

; d552-
; ̂܂܎gp
;
	org	$d552
	db	$ff

; d8c1-d8c3
; VRAM֘A
;
	org	$d8c1
	jr	$d8c4

; d8c4-
; ̂܂܎gp
;
	org	$d8c4
	db	$ff

; d8ca-d92a
; Q[L[
;
	org	$d8ca
KEYIN:
	ld	a,(GAMEDATA)
	and	$0f		; 0000 E
	add	a,a
	ld	hl,KEYTBL
	add	a,l
	ld	l,a
	jr	nc,.n1
	inc	h
.n1:
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a
	jp	(hl)

KEYTBL:
	dw	$dc01	; 0000 ; 0000
	dw	$daf0	; 000u ; 0001
	dw	$d9b6	; 00d0 ; 0010
	dw	$dc01	; 0000 ; 0011
	dw	$da20	; 0l00 ; 0100
	dw	$da81	; 0l0u ; 0101
	dw	$d957	; 0ld0 ; 0110
	dw	$dc01	; 0000 ; 0111
	dw	$da53	; r000 ; 1000
	dw	$db3f	; r00u ; 1001
	dw	$d9d9	; r0d0 ; 1010
	dw	$dc01	; 0000 ; 1011
	dw	$dc01	; 0000 ; 1100
	dw	$dc01	; 0000 ; 1101
	dw	$dc01	; 0000 ; 1110
	dw	$dc01	; 0000 ; 1111

; d92b-
; ̂܂܎gp
;
	org	$d92b
	db	$ff

; de5d-de60
; pbgݒ
;
	org	$de5d
	ld	a,$0f!$0f	; pbgݒi"00"=j
	out	($43),a	

; de61-
; ̂܂܎gp
;
	org	$de61
	db	$ff

; df78-df87
; Q[L[
;
	org	$df78
	ld	a,(GAMEDATA)
	and	$20
	jr	nz,$df8e
	jr	$df88

; df88-
; ̂܂܎gp
;
	org	$df88
	db	$ff

; dfb9-dfbc
; pbgݒ
;
	org	$dfb9
	ld	a,$0f!$0f	; pbgݒi"00"=j
	out	($43),a	

; dfbd-
; ̂܂܎gp
;
	org	$dfbd
	db	$ff

; dfc0-dfd8
; Q[L[
;
	org	$dfc0
TRG1DET:
	ld	a,(GAMEDATA)
	and	$10
	ld	a,($fff8)
	jr	nz,.lp1

	or	a
	jr	nz,$dfda
	ld	(hl),$ff
	ret
.lp1:
	or	a
	jr	z,$dfda

	xor	a
	jp	GAMESTART

; dfd9-
; ̂܂܎gp
;
	org	$dfd9
	db	$ff

; e024-e027
; \p^[
;
	org	$e024
	ld	iy,$8c10	; SHOTe2

; e028-
; ̂܂܎gp
;
	org	$e028
	db	$ff

; e046-e049
; \p^[
;
	org	$e046
	ld	iy,$8c10	; SHOTe2

; e04a-
; ̂܂܎gp
;
	org	$e04a
	db	$ff

; e06a-e06d
; \p^[
;
	org	$e06a
	ld	iy,$8c08	; SHOTe1

; e06e-
; ̂܂܎gp
;
	org	$e06e
	db	$ff

; e08d-e090
; \p^[
;
	org	$e08d
	ld	iy,$8c18	; SHOTe3

; e091-
; ̂܂܎gp
;
	org	$e091
	db	$ff

; e0b1-e0b4
; \p^[
;
	org	$e0b1
	ld	iy,$8c08	; SHOTe1

; e0b5-
; ̂܂܎gp
;
	org	$e0b5
	db	$ff

; e0d4-e0d7
; \p^[
;
	org	$e0d4
	ld	iy,$8c18	; SHOTe3

; e0d8-
; ̂܂܎gp
;
	org	$e0d8
	db	$ff

; e12a-e12d
; \p^[
;
	org	$e12a
	ld	ix,$8c80	; LASERe

; e12e-
; ̂܂܎gp
;
	org	$e12e
	db	$ff

; e152-e155
; \p^[
;
	org	$e152
	ld	ix,$8c80	; LASERe

; e156-
; ̂܂܎gp
;
	org	$e156
	db	$ff

; e17a-e17d
; \p^[
;
	org	$e17a
	ld	ix,$8c80	; LASERe

; e17e-
; ̂܂܎gp
;
	org	$e17e
	db	$ff

; e238-e23a
; \p^[
;
	org	$e238
	ld	de,$8c20	; HOMINGe

; e23b-
; ̂܂܎gp
;
	org	$e23b
	db	$ff

; e2b7-e2b9
; \p^[
;
	org	$e2b7
	ld	hl,$8c40	; e

; e2ba-
; ̂܂܎gp
;
	org	$e2ba
	db	$ff

; e2d2-e2d4
; \p^[
;
	org	$e2d2
	ld	de,$8c00	; 

; e2d5-
; ̂܂܎gp
;
	org	$e2d5
	db	$ff

; e2e3-e2e5
; \p^[
;
	org	$e2e3
	ld	de,$8c00	; 

; e2e6-
; ̂܂܎gp
;
	org	$e2e6
	db	$ff

; e2f9-e2fc
; \p^[
;
	org	$e2f9
	ld	iy,$8c10	; SHOTe2

; e2fd-
; ̂܂܎gp
;
	org	$e2fd
	db	$ff

; e309-e30c
; \p^[
;
	org	$e309
	ld	iy,$8c08	; SHOTe1

; e30d-
; ̂܂܎gp
;
	org	$e30d
	db	$ff

; e31b-e31e
; \p^[
;
	org	$e31b
	ld	iy,$8c08	; SHOTe1

; e31f-
; ̂܂܎gp
;
	org	$e31f
	db	$ff

; e32b-e32e
; \p^[
;
	org	$e32b
	ld	iy,$8c18	; SHOTe3

; e32f-
; ̂܂܎gp
;
	org	$e32f
	db	$ff

; e33d-e340
; \p^[
;
	org	$e33d
	ld	iy,$8c18	; SHOTe3

; e341-
; ̂܂܎gp
;
	org	$e341
	db	$ff

; e3ad-e3af
; \p^[
;
	org	$e3ad
	ld	de,$8c00	; 

; e3b0-
; ̂܂܎gp
;
	org	$e3b0
	db	$ff

; e436-e438
; \p^[
;
	org	$e436
	ld	de,$8c20	; HOMINGe

; e439-
; ̂܂܎gp
;
	org	$e439
	db	$ff

; e538-e53e
; VRAM֘A
;
	org	$e538
	jr	$e53f

; e53f-
; ̂܂܎gp
;
	org	$e53f
	db	$ff

end

